import unittest, sys
import io
import unittest.mock
import random, math
import numpy as np

from tmc import points

from tmc.utils import load, get_out

main = load('src.main', 'main')

class MainTest(unittest.TestCase):
   
    @points('1-6')
    def test_answer(self):

        n = 10000 # size of the problem: number of possible solutions x = 0, ..., n-1

        # generate random mountains                                                                               	 
        def mountains(n):
            h = [0]*n
            for i in range(50):
                c = random.randint(20, n-20)
                w = random.randint(3, int(math.sqrt(n/5)))**2
                s = random.random()
                h[max(0, c-w):min(n, c+w)] = [h[i] + s*(w-abs(c-i)) for i in range(max(0, c-w), min(n, c+w))]

            # scale the height so that the lowest point is 0.0 and the highest peak is 1.0
            low = min(h)
            high = max(h)
            h = [y - low for y in h]
            h = [y / (high-low) for y in h]
            return h
        
        # main()
        # self.assertGreater(h[x], h[max(0, x - 1)])
        # self.assertGreater(h[x], h[min(n-1, x + 1)])

        # output = list(get_out().split("\n"))

        count = 0

        for i in range(100):
            # generate new mountains for every 5th repetition
            if (i % 5 == 0): h = mountains(n)
            # start at a random place
            x0 = random.randint(1, n-1)
            x = main(h, x0)

            if h[x] > 0.95 * max(h):
                count += 1      
      
        self.assertGreater(count, 70)           

if __name__ == '__main__':
    unittest.main()
